#include <iostream>
using namespace std;

class Point1D {

public:
	explicit Point1D(int x = 0) : x(x) {}
	virtual ~Point1D() = default;
	virtual void show() { cout << "x = " << x << endl; }
	virtual Point1D& operator++() {
		x++; 
		cout << "Base increment \n";
		return *this;
	}

protected:
	int x;
};

class Point2D : public Point1D {

public:
	explicit Point2D(int x = 0, int y = 0) : Point1D(x), y(y) {}
	void show() override {
		Point1D::show();
		cout << "y = " << y << endl;
	}
	Point1D& operator++() override {
		x++; 
		y++; 
		cout << "Derived increment \n";
		return *this;
	}

private:
	int y;
};

int main() {
	Point2D point2D(1, 4);
	Point1D& point1D_reference = point2D;

	point2D.show();
	cout << endl;

	++point1D_reference;
	point1D_reference.show();
	cout << endl;

	(++point1D_reference).show();
	return 0;
}

