#include <iostream>
using namespace std;

class Car {
public:
	virtual ~Car() = default;
	virtual // try both versions
	void who_am_i() {
		cout << "\tI am Car\n";
	}
};

class Audi : public Car {
public:
	void who_am_i() override {
//	void who_am_i() {
		cout << "\tI am Audi\n";
	}
};

class Opel : public Car {
public:
	void who_am_i() override {
//	void who_am_i() {
		cout << "\tI am Opel\n";
	}
};

void who_is_she (Car &car) {
	car.who_am_i();
}

void who_is_she (Car *car) {
	car->who_am_i();
}


int main () {
	Car car;
	Audi audi;
	Opel opel;

	cout <<"Calls with Car pointer:" << endl;
	who_is_she(&car);
	who_is_she(&audi);
	who_is_she(&opel);
	cout << endl;

	cout <<"Calls with Car reference:" << endl;
	who_is_she(car);
	who_is_she(audi);
	who_is_she(opel);

	return 0;
}

